#include "/usr/include/qt/qapplication.h" // i paths degli header files installati sul mio sistema
#include "/usr/include/qt/qpushbutton.h"
#include "/usr/include/qt/qfont.h"
#include "/usr/include/qt/qlineedit.h"
#include "/usr/include/qt/qlabel.h"
#include "/usr/include/qt/qwidget.h"
#include "/usr/include/qt/qmessagebox.h"

#include "string.h"

class Controllo : public QWidget {

Q_OBJECT  // macro necessaria se si vogliono immettere slots e/o signals

public:
Controllo(QWidget *parent=0, const char *name=0);
// costruttore che imposta il nostro widget a top level window

public slots:
void decodifica(); // la nostra slot

private:
QPushButton* quit; // definizione dei widgets child che useremo nel nostro crackme
QLabel *qlab;  // chiaramente potete inserirne a vostro piacimento
QLabel *info;
QLineEdit *qle;
};

// codice del costruttore della classe Controllo

Controllo::Controllo (QWidget *parent, const char *name):QWidget (parent,name)
{

setCaption ("title bar");  // immette il titolo alla finestra
setMinimumSize( 200, 180 );
// misure massime e minime per la finestra coincidono
setMaximumSize( 200, 180 );  // quindi non  possibile far variare la sua misura

quit = new QPushButton ( "Check It",this,"check" ); // crea il pulsante che useremo per il controllo del seriale
quit->move( 47, 40 );
quit->resize( 106, 30 );
quit->setFont( QFont( "helvetica", 18, QFont::Bold ) );
qlab = new QLabel("SERIALE : ",this,"hl"); // crea l'etichetta da affiancare alla edit line per il seriale
info = new QLabel("",this,"nfo");  // nuova etichetta "espansa" come Box in cui scrivere informazioni personali e regole per il crack me
info->setFrameStyle( QFrame::Box | QFrame::Sunken);
info->setText ("info e condizioni di regolamento"); // controllare le specifiche per le informazioni varie di dimensionamento,etc...
info->move(1,75);
info->resize(200,100);
info->setAlignment(AlignHCenter | AlignVCenter);

qle = new QLineEdit(this); // creazione della edit line su cui viene inserito il seriale per un massimo di 15 caratteri
qle->setMaxLength(15);
qle->move(80,1);
qle->resize(120,30);

connect( quit, SIGNAL(clicked()), SLOT(decodifica())); // 2 connects che controllano il seriale quando viene premuto il pulsante
connect( qle, SIGNAL(returnPressed()), SLOT(decodifica())); // o quando viene premuto enter nella edit line
}

// codice della funzione decodifica() interna allla classe Controllo

void Controllo::decodifica() {

bool flagga=FALSE;

// dove inserirete la vostra eventuale routine di crypt del codice
// qle->text() preleva il seriale dalla edit line

if (flagga == TRUE)  // condizione che si verifica nel caso si indovini il seriale
QMessageBox::information ( 0,"titolo della message box","INDOVINATO", QMessageBox::Ok);
else
QMessageBox::information ( 0,"titolo della message box","SBAGLIATO", QMessageBox::Ok);
// le message box sono varie nelle qt, quindi vi consiglio di controllare le specifiche
// chiaramente questo  solo una semplice impostazione di routine di crypt e controllo che
// potete variare a vostro piacimento

}

#include "crackme.moc"  // importante : imposta la tavola di puntatori per le slots e i signals
int main (int argc,char **argv)

{
QApplication a (argc,argv);
Controllo w; // questa riga sostituisce ora QWidget w;
a.setMainWidget( &w );
w.show();
return a.exec();
}

